package Chainmail::DeliveryMethod::Sendmail;

use Chainmail::Report;

$sendmail_args = " ";
$sendmail_prog = "/usr/sbin/sendmail";

sub deliver 
{ 
  shift;
  my $message = shift;

  my @replytos = $message->get_reply_to();
  my $replyto = $replytos[0]->get_text();

  my @recipients = $message->get_recipients();
  if ( !(@recipients) )
    {
      die "no recipients\n";
    }

  my $contents = $message->get_contents();

  $_ = $contents;

  $contents .= "\n"
    unless /((\n)|(\n\.))$/;

  my $recipient_list = "";

  foreach my $r (@recipients)
    {
      $recipient_list .= "'" . $r->get_text() . "' ";
    }

  debug( "Recipients list: $recipient_list" );
  
  open(SENDMAIL, 
       "| $sendmail_prog $sendmail_args -f '$replyto' $recipient_list" )
    || die "can't fork $sendmail_prog: $!\n";
    
  local $SIG{PIPE} = sub { die "chainmail: pipe broke to $sendmail_prog" };
   
  print SENDMAIL "$contents";
   
  close SENDMAIL 
    || die "chainmail: error closing pipe to $sendmail_prog: $! $?\n";
  1;
}

1;
